library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity test_gclk is
Port ( clk : in std_logic;
	kp_o : out std_logic);
end test_gclk;

architecture Behavioral of test_gclk is
	signal halff: STD_LOGIC;
	signal ledct: STD_LOGIC_VECTOR(19 downto 0);

begin
--kp_o <= '1' when ledct>=X"1312c" else '0';	--at 40MHz
kp_o <= '1' when ledct>=X"17fd7" else '0';	--at 50MHz
process (CLK) 
begin
if CLK='1' and CLK'event then
--	if ledct=X"26259" then		--256Hz at 40MHz
	if (ledct>=X"2faef" and halff='0') or (ledct>=X"2faf0" and halff='1') then		--256Hz at 50MHz
		ledct <= (others=>'0');
		halff <= not halff;
	else
		ledct <= ledct+1;
	end if;
end if;
end process;

end Behavioral;
